package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.ASTVisitor;
import org.eclipse.jdt.internal.compiler.ast.Expression;
import org.eclipse.jdt.internal.compiler.ast.StringLiteral;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;

public class StringLiteralConcatenation extends StringLiteral {
  private static final int INITIAL_SIZE = 5;
  
  public Expression[] literals;
  
  public int counter;
  
  public StringLiteralConcatenation(StringLiteral str1, StringLiteral str2) {
    super(str1.sourceStart, str1.sourceEnd);
    this.source = str1.source;
    this.literals = (Expression[])new StringLiteral[5];
    this.counter = 0;
    this.literals[this.counter++] = (Expression)str1;
    extendsWith(str2);
  }
  
  public org.eclipse.jdt.internal.compiler.ast.StringLiteralConcatenation extendsWith(StringLiteral lit) {
    this.sourceEnd = lit.sourceEnd;
    int literalsLength = this.literals.length;
    if (this.counter == literalsLength)
      System.arraycopy(this.literals, 0, this.literals = (Expression[])new StringLiteral[literalsLength + 5], 0, literalsLength); 
    int length = this.source.length;
    System.arraycopy(
        this.source, 
        0, 
        this.source = new char[length + lit.source.length], 
        0, 
        length);
    System.arraycopy(lit.source, 0, this.source, length, lit.source.length);
    this.literals[this.counter++] = (Expression)lit;
    return this;
  }
  
  public StringBuffer printExpression(int indent, StringBuffer output) {
    output.append("StringLiteralConcatenation{");
    for (int i = 0, max = this.counter; i < max; i++) {
      this.literals[i].printExpression(indent, output);
      output.append("+\n");
    } 
    return output.append('}');
  }
  
  public char[] source() {
    return this.source;
  }
  
  public void traverse(ASTVisitor visitor, BlockScope scope) {
    if (visitor.visit(this, scope))
      for (int i = 0, max = this.counter; i < max; i++)
        this.literals[i].traverse(visitor, scope);  
    visitor.endVisit(this, scope);
  }
}
